﻿using System.Data;
using System.Web.Http;
using System.Web.Http.ModelBinding;
using Kendo.Mvc.UI;
using Kreta.BusinessLogic.Helpers;
using Kreta.BusinessLogic.Security;
using Kreta.Web.Areas.Tanulo.Models;
using Kreta.Web.Helpers;
using Kreta.Web.Helpers.Grid;
using Kreta.Web.Security;
using Newtonsoft.Json;

namespace Kreta.Web.Areas.Tanulo.ApiControllers
{
    [ApiRoleClaimsAuthorize(true)]
    [ApiRolePackageAuthorize(KretaClaimPackages.Tanar.ClaimValue)]
    public class TanarTanitottTanulokApiController : ApiController
    {
        public DataSourceResult GetTanarTanitottTanulokGrid(string data, [ModelBinder(typeof(ModelBinder.DataSourceRequestModelBinder))] DataSourceRequest request)
        {
            var model = JsonConvert.DeserializeObject<TanarTanitottTanulokSearchModel>(data);

            var helper = new TanarHelper(ConnectionTypeExtensions.GetSessionConnectionType());
            helper.GridParameters = Converter.GridParameter(request);
            DataSet ds = helper.GetTanarTanulok(
                model.Foglalkozas,
                model.FoglalkozasTipus,
                model.CsakBukasraAllok ?? false,
                model.FeladatKategoriaId
            );

            return ds.ToDataSourceResult();
        }
    }
}
