﻿using System.Web.Http;
using System.Web.Http.ModelBinding;
using Kendo.Mvc.UI;
using Kreta.BusinessLogic.Helpers;
using Kreta.BusinessLogic.Security;
using Kreta.Web.Helpers;
using Kreta.Web.Helpers.Grid;
using Kreta.Web.Security;

namespace Kreta.Web.Areas.Tanulo.ApiControllers
{
    [ApiRoleClaimsAuthorize(true)]
    [ApiRolePackageAuthorize(KretaClaimPackages.CsokkentettGondviselo.ClaimValue)]
    public class TanulotTanitoTanarokApiController : ApiController
    {
        public DataSourceResult GetTanulotTanitoTanarGrid(string data, [ModelBinder(typeof(ModelBinder.DataSourceRequestModelBinder))] DataSourceRequest request)
        {
            var helper = new TanarHelper(ConnectionTypeExtensions.GetActiveSessionConnectionType());
            helper.GridParameters = Converter.GridParameter(request);
            var ds = helper.GetTanulotTanitoTanarok(ClaimData.FelhasznaloId);
            return ds.ToDataSourceResult();
        }
    }
}
